︠2a6e0662-76d7-4925-81ea-f28ffb251192i︠
%html
<h1><center>BABY STEP GIANT STEP ATTACK ON DISCRETE LOG PROBLEM</center></h1>
︡3f4e5fef-b082-4f90-a667-79bf1da9c268︡{"done":true,"html":"<h1><center>BABY STEP GIANT STEP ATTACK ON DISCRETE LOG PROBLEM</center></h1>"}
︠b6c42a13-6531-480d-b164-8c7215763fb0i︠
%html
<h2>The BSGS procedure solves the DLP $b=g^x$ where p is the prime number, g is a primitive root of p and b is the public value of the El Gamal public key.</h2>
︡ffaf47c4-0d95-4a97-96c4-06da4c9e9309︡{"done":true,"html":"<h2>The BSGS procedure solves the DLP $b=g^x$ where p is the prime number, g is a primitive root of p and b is the public value of the El Gamal public key.</h2>"}
︠415afbca-535f-4c08-8240-3cd46c5fcd0bs︠
def BSGS(g,b,p):
    N=p-1
    m=floor(sqrt(N))+1
    B=[]
    G=[]
    B.append(1)

    for j in range(1,m):
        B.append(power_mod(g,j,p))

    p2 = power_mod(g,m,p)
    for j in range(0,m-1):
        tempVal = b* power_mod(p2,-j,p) % p
        for i in range(len(B)):
            if(tempVal == B[i]):
                return (i+(m*j)) % (p-1)

    print("ERROR: didn't find private key")
    return -1
︡3f754fd1-82c9-488d-9341-5df9e8dddd56︡{"done":true}
︠42e9170d-f078-4d5e-8baf-40cc9876bf4ci︠
%html
<h3>Example 1. Let p= 738443, g=23, b=293. Solve the DLP $b=g^x$ using BSGS.</h3>
︡0edf3d2c-7368-432f-a36a-bd39d5ab9719︡{"done":true,"html":"<h3>Example 1. Let p= 738443, g=23, b=293. Solve the DLP $b=g^x$ using BSGS.</h3>"}
︠e6a311b1-9d8c-4b51-8653-55273b555b38s︠
p=738443
b=293
g=23
x=BSGS(g,b,p)
print("The recovered private key is " , x)
print("Using recovered private key we re-comptue the b value" , power_mod(g,x,p), "and compare it to the known value", b)

︡2b3056c4-3813-4071-9692-13b8d9297770︡{"stdout":"The recovered private key is  172388\n"}︡{"stdout":"Using recovered private key we re-comptue the b value 293 and compare it to the known value 293\n"}︡{"done":true}
︠9a0b8c0a-8dee-4dcf-9d3a-4e33cb03486fi︠
%html
<h3>Example 2. Let p= 5623571, g=2, b=2162125. Solve the DLP $b=g^x$ using BSGS.</h3>
︡dc0ab53b-fd5e-4463-9b9c-69e41ffc57ee︡{"done":true,"html":"<h3>Example 2. Let p= 5623571, g=2, b=2162125. Solve the DLP $b=g^x$ using BSGS.</h3>"}
︠8b08c865-5192-4dc5-96d4-6907c4214881s︠

p = 5623571
g = 2
b = 2162125
x = BSGS(g,b,p)
print("The recovered key is", x)
print("Using recovered private key we re-comptue the b value" , power_mod(g,x,p), "and compare it to the known value", b)
︡52a6d727-040e-432c-b039-30ae31bddeea︡
︠b45e2555-bc44-4db8-b2a1-4ead134551c9i︠
%html
<h3>Example 3. Let p= 8989899007, g=17, b=7096854884. Solve the DLP $b=g^x$ using BSGS.</h3>
︡f695a1e2-e7cf-40e8-985c-d4eef47ad8c8︡{"done":true,"html":"<h3>Example 3. Let p= 8989899007, g=17, b=7096854884. Solve the DLP $b=g^x$ using BSGS.</h3>"}
︠27dc4a05-8a3b-4ac2-9c0a-7b0e15957ad6s︠
p = 8989899007
g = 17
b = 7096854884
x = BSGS(g,b,p)
print("stdout":"17\n"}
︡c70b5b50-7e92-4bac-ab3d-2177ddee4e0b︡
︠6caae690-7658-44bf-abdf-5ef03c7053f7s︠

︡e584200b-e36c-4585-8cc8-8a93680f78c7︡{"done":true}
︠17bf4f62-cbae-4fc2-a17f-6f1b9a58334cs︠

︡4828a0fb-ca23-4233-9c5e-e7985928d9c6︡{"done":true}









